function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime_1 = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var runtime = (function (exports) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined$1; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  exports.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] =
    GeneratorFunction.displayName = "GeneratorFunction";

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      prototype[method] = function(arg) {
        return this._invoke(method, arg);
      };
    });
  }

  exports.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  exports.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  exports.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return Promise.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return Promise.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration.
          result.value = unwrapped;
          resolve(result);
        }, function(error) {
          // If a rejected Promise was yielded, throw the rejection back
          // into the async generator function so it can be handled there.
          return invoke("throw", error, resolve, reject);
        });
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new Promise(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  exports.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  exports.async = function(innerFn, outerFn, self, tryLocsList) {
    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList)
    );

    return exports.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined$1) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        // Note: ["return"] must be used for ES3 parsing compatibility.
        if (delegate.iterator["return"]) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined$1;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined$1;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  Gp[toStringTagSymbol] = "Generator";

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  exports.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined$1;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  exports.values = values;

  function doneResult() {
    return { value: undefined$1, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined$1;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined$1;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined$1;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined$1;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined$1;
      }

      return ContinueSentinel;
    }
  };

  // Regardless of whether this script is executing as a CommonJS module
  // or not, return the runtime object so that we can declare the variable
  // regeneratorRuntime in the outer scope, which allows this module to be
  // injected easily by `bin/regenerator --include-runtime script.js`.
  return exports;

}(
  // If this script is executing as a CommonJS module, use module.exports
  // as the regeneratorRuntime namespace. Otherwise create a new empty
  // object. Either way, the resulting object will be used to initialize
  // the regeneratorRuntime variable at the top of this file.
   module.exports 
));

try {
  regeneratorRuntime = runtime;
} catch (accidentalStrictMode) {
  // This module should not be running in strict mode, so the above
  // assignment should always work unless something is misconfigured. Just
  // in case runtime.js accidentally runs in strict mode, we can escape
  // strict mode using a global Function call. This could conceivably fail
  // if a Content Security Policy forbids using Function, but in that case
  // the proper solution is to fix the accidental strict mode problem. If
  // you've misconfigured your bundler to force strict mode and applied a
  // CSP to forbid Function, and you're not willing to fix either of those
  // problems, please detail your unique predicament in a GitHub issue.
  Function("r", "regeneratorRuntime = r")(runtime);
}
});

var regenerator = runtime_1;

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

/*
 * Created Date: 2019-07-09
 * Author: 宋慧武
 * ------
 * Last Modified: Tuesday 2019-07-09 18:09:50 pm
 * Modified By: the developer formerly known as 宋慧武 at <songhuiwu001@ke.com>
 * ------
 * HISTORY:
 * ------
 * Javascript will save your soul!
 */
/**
 * @desc 获取 DOM CSS 属性的值
 *
 * @param {DOMElement} ele A DOM 元素
 * @returns {String}
 */

function getStylePropValue(ele, prop) {
  return window.getComputedStyle(ele).getPropertyValue(prop);
}
/**
 * @desc 元素是否隐藏
 *
 * @param {DOMElement} ele A DOM 元素
 * @returns {Boolean} true => 未隐藏可见  false => 隐藏不可见
 */

function isVisible(ele) {
  if (ele === window.document) {
    return true;
  }

  if (!ele || !ele.parentNode) {
    return false;
  }

  var parent = ele.parentNode;
  var visibility = getStylePropValue(ele, "visibility");
  var display = getStylePropValue(ele, "display");

  if (visibility === "hidden" || display === "none") {
    return false;
  }

  return parent ? isVisible(parent) : true;
}

/*
 * Created Date: 2019-07-11
 * Author: 宋慧武
 * ------
 * Last Modified: Monday 2019-07-22 17:44:20 pm
 * Modified By: the developer formerly known as 宋慧武 at <songhuiwu001@ke.com>
 * ------
 * HISTORY:
 * ------
 * Javascript will save your soul!
 */

/**
 * @desc 获取对象的键值
 *
 * @param {Object} value
 * @returns {Array} [keys, values]
 */
function zipObject(value) {
  return [Object.values(value), Object.keys(value)];
}
/**
 * @desc 判断给定变量是否为一个函数
 *
 * @param {*} v
 * @return {Boolean}
 */

var isFun = function isFun(v) {
  return typeof v === "function" || false;
};
/**
 * @desc 清除定时器
 */

var clearTimeoutQueue = function clearTimeoutQueue() {
  var queue = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  Object.keys(queue).forEach(function (timer) {
    clearTimeout(queue[timer]);
  });
};

/*
 * Created Date: 2019-07-22
 * Author: 宋慧武
 * ------
 * Last Modified: Tuesday 2019-07-23 11:54:20 am
 * Modified By: the developer formerly known as 宋慧武 at <songhuiwu001@ke.com>
 * ------
 * HISTORY:
 * ------
 * Javascript will save your soul!
 */
/**
 * @desc chenck 埋点ID是否合法
 *
 * @param {Object} events 当前模块的所有埋点
 * @param {Object} eventId 埋点事件id
 */

var vaildEvent = function vaildEvent(events, eventId) {
  if (!isFun(events[eventId])) {
    throw new Error("track eventId '".concat(eventId, "' does not exist"));
  }
};
/**
 * @desc check 异步埋点监听key是否存在
 */

var vaildWatchKey = function vaildWatchKey(stateKey, propKey) {
  if (!stateKey && !propKey) {
    throw new Error("Missing arguments.{stateKey} or arguments.{propKey} in async track");
  }
};
/**
 * @desc check 当前实例是否为react组件
 */

var vaildRC = function vaildRC(isRC) {
  if (!isRC) {
    throw new Error("The current instance is not a react component");
  } else {
    return isRC;
  }
};

var ONCE = "once";
var modifiers = {
  UVPV: "UVPV",
  // 特殊的修饰符
  TONP: "TONP",
  // 特殊的修饰符，表示页面停留时长
  TRIGGER: "trigger",
  TRIGGER_AFTER: "trigger.after",
  ASYNC: "async",
  ASYNC_DELAY: "async.delay"
};
/**
 * @desc inject 装饰器
 * @param {Function} reaction 如果为 Mobx Class 则需要注入 mobx.reaction 来监听通过异步action 对 state 的改变
 * @param {Object} trackEvents 当前页面需要的埋点事件
 */

var inject = function inject() {
  for (var _len = arguments.length, props = new Array(_len), _key = 0; _key < _len; _key++) {
    props[_key] = arguments[_key];
  }

  return function (target) {
    Object.assign.apply(Object, [target.prototype].concat(props));
  };
};
/**
 * @desc track 埋点装饰器
 * @param {String} modifier 修饰符，对应的埋点类型
 * @param {Number | String} eventId 埋点事件id
 * @param {Object} params 自定义参数，目前支持tateKey、propKey、delay、ref
 *
 * @property[stateKey] 对应组件 state 或者 mobx observable 中 key
 * @property[propKey] 对应组件 props 中 key
 * @property[delay] 埋点延迟时间
 * @property[ref] 对应 DOM 的引用，避免小于埋点延迟时间内发生DOM影藏造成埋点继续上报的问题
 */

function track(modifier, eventId) {
  var params = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var _zipObject = zipObject(modifiers),
      _zipObject2 = _slicedToArray(_zipObject, 1),
      mdfs = _zipObject2[0]; // 获取模块对应的埋点的适配器


  function getTrackEvents(ctx) {
    return ctx.trackEvents || ctx.props.trackEvents;
  } // 当前实例是否为react class组件


  function checkRC(ctx) {
    return ctx.isReactComponent;
  } // 生成唯一的once标记属性


  function createOnceProp(name, eventId) {
    return "".concat(name, "_").concat(eventId, "_").concat(ONCE);
  } // 描述符value适配器


  function valueAdapter(ctx, value, initializer, args) {
    if (value) {
      return value.bind(ctx);
    }

    if (initializer) {
      return initializer.apply(ctx, args);
    }
  } // 生成不同队列，即value执行前的值


  function queueAdapter(ctx, fn, tck, ops) {
    if (ops.after) {
      return [fn, ops.isRC ? function () {
        return ctx.setState({}, tck);
      } : tck];
    } else {
      return [tck, fn];
    }
  }

  if (!mdfs.includes(modifier.replace(/\.once/g, ""))) {
    throw new Error("modifier '".concat(modifier, "' does not exist"));
  }

  return function (_, name, descriptor) {
    var handler;
    var value = descriptor.value,
        initializer = descriptor.initializer; // 页面初始化埋点

    if (modifier.includes(modifiers.UVPV)) {
      handler = function handler() {
        var _this = this;

        for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
          args[_key2] = arguments[_key2];
        }

        vaildRC(this.isReactComponent);
        var evts = getTrackEvents(this);
        var fn = valueAdapter(this, value, initializer, args);

        var tck = function tck() {
          var _evts$modifier;

          var context = _objectSpread({}, _this.state, _this.props);

          (_evts$modifier = evts[modifier]).call.apply(_evts$modifier, [null, context].concat(args));
        };

        return [tck, fn].forEach(function (sub) {
          return sub.apply(void 0, args);
        });
      };
    } // 设置进入页面时间
    else if (modifier.includes(modifiers.TONP)) {
        handler = function handler() {
          var _this2 = this;

          var isRC = vaildRC(this.isReactComponent); // 是否为 react 组件

          var evts = getTrackEvents(this);

          var tck = function tck() {
            var stt = Date.now() - _this2.__trackPageEntryTime;

            var context = _objectSpread({}, _this2.state, _this2.props);

            evts[modifier].call(null, context, {
              stt: stt
            });
          };

          this.__trackPageEntryTime = Date.now(); // 页面卸载前上报埋点

          if (isRC && !this.componentWillUnmount) {
            this.needMergeTONPWillUnmount = false;

            this.componentWillUnmount = function () {
              return tck();
            };
          } else if (this.componentWillUnmount && this.needMergeTONPWillUnmount !== false) {
            var willUnmountRef = this.componentWillUnmount;

            this.componentWillUnmount = function () {
              willUnmountRef.apply(_this2);
              tck();
            };
          }

          for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
          }

          return value ? value.apply(this, args) : initializer.apply(this, args).apply(void 0, args);
        };
      } // 事件行为埋点(支持同步、异步)
      else if ((modifier.includes(modifiers.TRIGGER) || modifier.includes(modifiers.ASYNC)) && !params.stateKey && !params.propKey) {
          handler = function handler() {
            var _this3 = this;

            for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
              args[_key4] = arguments[_key4];
            }

            var tck;
            var context = this;
            var isRC = checkRC(this); // 是否为 react 组件

            var evts = getTrackEvents(this);
            var onceProp = createOnceProp(name, eventId);
            var fn = valueAdapter(this, value, initializer, args);
            var after = modifier.includes(modifiers.TRIGGER_AFTER) || modifier.includes(modifiers.ASYNC);

            tck = function tck() {
              var _evts$eventId;

              if (_this3[onceProp]) return; // 如果存在once修饰符，且为true则直接返回

              vaildEvent(evts, eventId); // 检测eventId是否合法

              isRC && (context = _objectSpread({}, _this3.state, _this3.props));

              (_evts$eventId = evts[eventId]).call.apply(_evts$eventId, [null, context].concat(args));

              modifier.includes(ONCE) && (_this3[onceProp] = true);
            };

            if (modifier === modifiers.ASYNC_DELAY || modifier === modifiers.ASYNC_DELAY + ".once") {
              !this.tckTimerQueue && (this.tckTimerQueue = {}); // 定时器队列

              tck = function tck() {
                var _params$delay = params.delay,
                    delay = _params$delay === void 0 ? 0 : _params$delay,
                    ref = params.ref;
                var ele = _this3[ref] || document;
                var timer = _this3.tckTimerQueue[eventId];
                timer && clearTimeout(timer);
                _this3.tckTimerQueue[eventId] = setTimeout(function () {
                  var _evts$eventId2;

                  isRC && (context = _objectSpread({}, _this3.state, _this3.props));
                  isVisible(ele) && (_evts$eventId2 = evts[eventId]).call.apply(_evts$eventId2, [null, context].concat(args));
                  clearTimeout(_this3.tckTimerQueue[eventId]);
                }, delay);
              }; // 页面卸载时清除进行中的定时器


              if (isRC && !this.componentWillUnmount) {
                this.needMergeWillUnmount = false;

                this.componentWillUnmount = function () {
                  clearTimeoutQueue(_this3.tckTimerQueue);
                };
              } else if (this.componentWillUnmount && this.needMergeWillUnmount !== false) {
                var willUnmountRef = this.componentWillUnmount;

                this.componentWillUnmount = function () {
                  willUnmountRef.apply(_this3);
                  clearTimeoutQueue(_this3.tckTimerQueue);
                };
              }
            }

            var queue = queueAdapter(this, fn, tck, {
              isRC: isRC,
              after: after
            });

            if (modifier.includes(modifiers.ASYNC)) {
              // 异步
              return _asyncToGenerator(
              /*#__PURE__*/
              regenerator.mark(function _callee() {
                var _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, iter;

                return regenerator.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        _context.prev = 3;
                        _iterator = queue[Symbol.iterator]();

                      case 5:
                        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                          _context.next = 12;
                          break;
                        }

                        iter = _step.value;
                        _context.next = 9;
                        return iter.apply(void 0, args);

                      case 9:
                        _iteratorNormalCompletion = true;
                        _context.next = 5;
                        break;

                      case 12:
                        _context.next = 18;
                        break;

                      case 14:
                        _context.prev = 14;
                        _context.t0 = _context["catch"](3);
                        _didIteratorError = true;
                        _iteratorError = _context.t0;

                      case 18:
                        _context.prev = 18;
                        _context.prev = 19;

                        if (!_iteratorNormalCompletion && _iterator.return != null) {
                          _iterator.return();
                        }

                      case 21:
                        _context.prev = 21;

                        if (!_didIteratorError) {
                          _context.next = 24;
                          break;
                        }

                        throw _iteratorError;

                      case 24:
                        return _context.finish(21);

                      case 25:
                        return _context.finish(18);

                      case 26:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, null, [[3, 14, 18, 26], [19,, 21, 25]]);
              }))();
            } else {
              // 同步
              return queue.forEach(function (sub) {
                return sub.apply(void 0, args);
              });
            }
          };
        } // 异步监听行为埋点
        else {
            handler = function handler() {
              var _this4 = this;

              for (var _len5 = arguments.length, args = new Array(_len5), _key5 = 0; _key5 < _len5; _key5++) {
                args[_key5] = arguments[_key5];
              }

              var tck;
              var context = this;
              var isRC = checkRC(this); // 是否为 react 组件

              var evts = getTrackEvents(this);
              var fn = valueAdapter(this, value, initializer, args);
              var once = modifier.includes(ONCE);
              var stateKey = params.stateKey,
                  propKey = params.propKey;
              var watchPropKey = "".concat(name, "_").concat(propKey, "_").concat(eventId); // 保证key的唯一性

              var watchStateKey = "".concat(name, "_").concat(stateKey, "_").concat(eventId);
              vaildEvent(evts, eventId);
              vaildWatchKey(stateKey, propKey);
              !this.tckQueue && (this.tckQueue = {}); // 在当前实例维护一个异步埋点队列

              !this.tckQueuePropKeys && (this.tckQueuePropKeys = []); //

              !this.tckQueueStateKeys && (this.tckQueueStateKeys = []); //

              if (modifier === modifiers.ASYNC_DELAY || modifier === modifiers.ASYNC_DELAY + ".once") {
                !this.tckTimerQueue && (this.tckTimerQueue = {}); // 定时器队列

                tck = function tck() {
                  var _params$delay2 = params.delay,
                      delay = _params$delay2 === void 0 ? 0 : _params$delay2,
                      ref = params.ref;
                  var ele = _this4[ref] || document;
                  var timer = _this4.tckTimerQueue[eventId];
                  timer && clearTimeout(timer);
                  _this4.tckTimerQueue[eventId] = setTimeout(function () {
                    var _evts$eventId3;

                    isRC && (context = _objectSpread({}, _this4.state, _this4.props));
                    isVisible(ele) && (_evts$eventId3 = evts[eventId]).call.apply(_evts$eventId3, [null, context].concat(args));
                    clearTimeout(_this4.tckTimerQueue[eventId]);
                  }, delay);
                }; // 页面卸载时清除进行中的定时器


                if (isRC && !this.componentWillUnmount) {
                  this.needMergeWillUnmount = false;

                  this.componentWillUnmount = function () {
                    clearTimeoutQueue(_this4.tckTimerQueue);
                  };
                } else if (this.componentWillUnmount && this.needMergeWillUnmount !== false) {
                  var willUnmountRef = this.componentWillUnmount;

                  this.componentWillUnmount = function () {
                    willUnmountRef.apply(_this4);
                    clearTimeoutQueue(_this4.tckTimerQueue);
                  };
                }
              } else if (modifier === modifiers.ASYNC || modifier === modifiers.ASYNC + ".once") {
                tck = function tck() {
                  var _evts$eventId4;

                  isRC && (context = _objectSpread({}, _this4.state, _this4.props));
                  if (propKey && _this4["".concat(watchPropKey, "_").concat(ONCE)]) return;
                  if (stateKey && _this4["".concat(watchStateKey, "_").concat(ONCE)]) return;

                  (_evts$eventId4 = evts[eventId]).call.apply(_evts$eventId4, [null, context].concat(args));

                  once && propKey && (_this4["".concat(watchPropKey, "_").concat(ONCE)] = true);
                  once && stateKey && (_this4["".concat(watchStateKey, "_").concat(ONCE)] = true);
                };
              }

              propKey && (this.tckQueue[watchPropKey] = [tck]) && this.tckQueuePropKeys.push(watchPropKey);
              stateKey && (this.tckQueue[watchStateKey] = [tck]) && this.tckQueueStateKeys.push(watchStateKey);

              var diffValDispatch = function diffValDispatch(prevProps, prevState) {
                Object.keys(_this4.tckQueue).forEach(function (watchKey) {
                  var oldVal, newVal, key;
                  key = watchKey.split("_")[1];

                  if (_this4.tckQueuePropKeys.includes(watchKey)) {
                    newVal = _this4.props[key];
                    oldVal = prevProps[key];
                  }

                  if (_this4.tckQueueStateKeys.includes(watchKey)) {
                    newVal = _this4.state[key];
                    oldVal = prevState[key];
                  }

                  if (oldVal !== newVal) {
                    _this4.tckQueue[watchKey].forEach(function (sub) {
                      return sub && sub();
                    });

                    _this4.tckQueue[watchKey] = []; // 清空当前watch的埋点队列
                  }
                });
              }; // 通过 react 生命周期函数 getSnapshotBeforeUpdate diff 值的变化控制埋点的上报


              if (isRC && !this.getSnapshotBeforeUpdate) {
                this.needMergeSnapshotBeforeUpdate = false;

                this.getSnapshotBeforeUpdate = function (prevProps, prevState) {
                  diffValDispatch(prevProps, prevState);
                  return null;
                };
              } else if (this.getSnapshotBeforeUpdate && this.needMergeSnapshotBeforeUpdate !== false) {
                var snapshotBeforeUpdate = this.getSnapshotBeforeUpdate;

                this.getSnapshotBeforeUpdate = function (prevProps, prevState) {
                  diffValDispatch(prevProps, prevState);
                  return snapshotBeforeUpdate.call(_this4, prevProps, prevState);
                };
              } else if (!isRC && this.reaction) {
                var cbks = this.tckQueue[watchStateKey];
                var disposer = this.reaction(function () {
                  return _this4[stateKey];
                }, function () {
                  cbks.forEach(function (sub) {
                    return sub && sub();
                  });
                  disposer();
                });
              }

              return fn.apply(void 0, args);
            };
          }

    if (value) {
      descriptor.value = function () {
        for (var _len6 = arguments.length, args = new Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
          args[_key6] = arguments[_key6];
        }

        return handler.apply(this, args);
      };
    } // 兼容箭头函数 https://github.com/MuYunyun/diana/issues/7


    if (initializer) {
      descriptor.initializer = function () {
        return handler.bind(this);
      };
    }
  };
}

export { inject, track };
